Global Window_Width  : Window_Width  = GetSystemMetrics_(#SM_CXSCREEN) 
Global Window_Height : Window_Height = GetSystemMetrics_(#SM_CYSCREEN) 
  Structure _GI_BITMAPINFO 
    bmiHeader.BITMAPINFOHEADER 
    bmiColors.RGBQUAD[1] 
  EndStructure 

  Structure _GI_LONG 
   l.l 
  EndStructure 

  Structure _GI_BGR 
   R.b 
   G.b 
   B.b 
   A.b 
  EndStructure 





#D_ReadBufferSize = 1024 

Structure D_ProgramInfo 
  StartUpInfo.STARTUPINFO 
  ProcessInfo.PROCESS_INFORMATION 
  SECURITYATTRIBUTES.SECURITY_ATTRIBUTES 
  hOutputPipeRead.l 
  hOutputPipeWrite.l 
  hInputPipeRead.l 
  hInputPipeWrite.l 
  hReadThread.l 
  ReadThreadStat.l 
  ReadBuffer.l 
  ReadDataLen.l 
EndStructure 

Procedure D_ReadConsoleOutputThread(*ProgramInfo.D_ProgramInfo) 
  *ProgramInfo\ReadBuffer = AllocateMemory(#D_ReadBufferSize) 
  *ProgramInfo\ReadThreadStat = 1 
  Repeat 
    If *ProgramInfo\ReadThreadStat = 1 
      If ReadFile_(*ProgramInfo\hOutputPipeRead,*ProgramInfo\ReadBuffer,#D_ReadBufferSize,@*ProgramInfo\ReadDataLen,0) 
        *ProgramInfo\ReadThreadStat = 2 
      EndIf 
    EndIf 
    Delay(1) 
  Until *ProgramInfo\ReadThreadStat = 0 
  FreeMemory(*ProgramInfo\ReadBuffer) 
  *ProgramInfo\hReadThread = #Null 
EndProcedure 

Procedure D_RunProgram(EXEFileName.s,Parameter.s,*ProgramInfo.D_ProgramInfo) 
  Protected result 
  result = #False 
  *ProgramInfo\SECURITYATTRIBUTES\nLength = SizeOf(SECURITY_ATTRIBUTES) 
  *ProgramInfo\SECURITYATTRIBUTES\bInheritHandle = 1 
  *ProgramInfo\SECURITYATTRIBUTES\lpSecurityDescriptor = 0 
  
  If CreatePipe_(@*ProgramInfo\hOutputPipeRead, @*ProgramInfo\hOutputPipeWrite, @*ProgramInfo\SECURITYATTRIBUTES, 0) And CreatePipe_(@*ProgramInfo\hInputPipeRead, @*ProgramInfo\hInputPipeWrite, @*ProgramInfo\SECURITYATTRIBUTES, 0) 
    *ProgramInfo\StartUpInfo\cb = SizeOf(STARTUPINFO) 
    *ProgramInfo\StartUpInfo\dwFlags = #STARTF_USESTDHANDLES | #STARTF_USESHOWWINDOW 
    *ProgramInfo\StartUpInfo\hStdOutput = *ProgramInfo\hOutputPipeWrite 
    *ProgramInfo\StartUpInfo\hStdError = *ProgramInfo\hOutputPipeWrite 
    *ProgramInfo\StartUpInfo\hStdInput = *ProgramInfo\hInputPipeRead 
    If CreateProcess_(#Null,Chr(34)+EXEFileName+Chr(34)+" "+Parameter,@*ProgramInfo\SECURITYATTRIBUTES,@*ProgramInfo\SECURITYATTRIBUTES,1,#NORMAL_PRIORITY_CLASS,#Null,#Null,@*ProgramInfo\StartUpInfo,@*ProgramInfo\ProcessInfo) 
      *ProgramInfo\hReadThread = CreateThread(@D_ReadConsoleOutputThread(),*ProgramInfo) 
      If *ProgramInfo\hReadThread 
        Delay(10) 
        result = #True 
      EndIf 
    EndIf 
    CloseHandle_(*ProgramInfo\hOutputPipeWrite) 
    CloseHandle_(*ProgramInfo\hInputPipeRead) 
  EndIf 
  ProcedureReturn result 
EndProcedure 

Procedure D_CloseProgram(*ProgramInfo.D_ProgramInfo) 
  *ProgramInfo\ReadThreadStat = 0 
  CloseHandle_(*ProgramInfo\ProcessInfo\hThread) 
  CloseHandle_(*ProgramInfo\hOutputPipeRead) 
  CloseHandle_(*ProgramInfo\hInputPipeWrite) 
  TerminateProcess_(*ProgramInfo\ProcessInfo\hProcess,0) 
  CloseHandle_(*ProgramInfo\ProcessInfo\hProcess) 
  If *ProgramInfo\hReadThread 
    KillThread(*ProgramInfo\hReadThread) 
  EndIf 
EndProcedure 

Procedure D_GetOutput(*ProgramInfo.D_ProgramInfo,Buffer) 
  Delay(5) 
  If *ProgramInfo\ReadThreadStat = 2 
    OemToCharBuff_(*ProgramInfo\ReadBuffer,Buffer,*ProgramInfo\ReadDataLen) 
    *ProgramInfo\ReadThreadStat = 1 
    ProcedureReturn *ProgramInfo\ReadDataLen 
  EndIf 
  ProcedureReturn #False 
EndProcedure 

Procedure D_SendInputString(*ProgramInfo.D_ProgramInfo,String.s) 
  Protected tmp.l 
  CharToOemBuff_(String,String,Len(String)) 
  If WriteFile_(*ProgramInfo\hInputPipeWrite,String,Len(String),@tmp,0) 
    ProcedureReturn tmp 
  EndIf 
  ProcedureReturn #False 
EndProcedure 

Procedure D_SendInput(*ProgramInfo.D_ProgramInfo,Buffer.l,Bufferlen.l) 
  Protected tmp.l 
  If WriteFile_(*ProgramInfo\hInputPipeWrite,Buffer,Bufferlen,@tmp,0) 
    ProcedureReturn tmp 
  EndIf 
  ProcedureReturn #False 
EndProcedure 

Mem = AllocateMemory(#D_ReadBufferSize) 

If InitNetwork() = 0
  MessageRequester("Error", "Can't initialize the network !", 0)
  End
EndIf
Port = 6832
Buffersize=4096
  
hwnd=OpenWindow(1,0,0,400,0,#PB_Window_SystemMenu|#PB_Window_MinimizeGadget |#PB_Window_MaximizeGadget |#PB_Window_ScreenCentered ,"PB Remote Server Edition") 
CreateGadgetList(WindowID()) 
Pic_desktop = CreateImage(1,Window_Width,Window_Height) 
ImageGadget(1,0,0,Window_Width,Window_Height,Pic_desktop) 

;SetWindowPos_(hwnd,#HWND_TOPMOST ,0,0,0,0,#SWP_NOSIZE |#SWP_SHOWWINDOW |#SWP_NOMOVE )
AddSysTrayIcon(1, WindowID() , 1)
;HideWindow(1, 1) 

If CreateNetworkServer(Port)
  ;MessageRequester("PureBasic - Server", "Server created (Port "+Str(Port)+").", 0)
Else
 ;problem 
EndIf  
CopyMode=0
Greymode=0
;HalfMode=1
Packmode=1
PackGreymode=0


L=Window_Width * Window_Height *4
;bmem = GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,L) 
bmem=AllocateMemory(L)

         bmi._GI_BITMAPINFO 
         bmi\bmiHeader\biSize   = SizeOf(BITMAPINFOHEADER) 
         bmi\bmiheader\biWidth  = Window_Width
         bmi\bmiheader\biHeight = Window_Height 
         bmi\bmiheader\biPlanes = 1 
         bmi\bmiheader\biBitCount = 32 
         bmi\bmiheader\biCompression = #BI_RGB 

GrayMem=GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,L/4)

Dest=GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,L*2) 
Workmem=GlobalAlloc_(#GMEM_FIXED|#GMEM_ZEROINIT,1024*1024)
PackL=L
ClientBuffersize=1024
ClientBuffer=AllocateMemory(ClientBuffersize)
GrabMode=0
 
  Repeat
  DOEVENTS()  

   If Commandprompt
    Len = D_GetOutput(@ProgramInfo.D_ProgramInfo,Mem) 
    If Len 
     If ClientID
      Debug PeekS(mem)
      BytesSended = SendNetworkData(ClientID, Mem, Len) 
    
      ;SetGadgetText(#Gadget_String,GetGadgetText(#Gadget_String)+PeekS(Mem,Len)+Chr(13)+Chr(10)) 
      EndIf 
     EndIf
   EndIf
   
    SEvent.l = NetworkServerEvent()
    If SEvent
      ClientID = NetworkClientID()
      Select SEvent
       Case 1
        For I=100 To 100
         Beep_(I,50)
        Next I 
        SetWindowTitle(1,"client "+Str(ClientID) + " connected")
        ;MessageRequester("PureBasic - Server", "A new client has connected !", 0)
       Case 2
        ;MessageRequester("PureBasic - Server", "Client "+Str(ClientID)+" has send a packet !", 0)
        BytesReceived=ReceiveNetworkData(ClientID, ClientBuffer, ClientBuffersize)
        
        ;MessageRequester("Info "+Str(BytesReceived), "String: "+PeekS(ClientBuffer), 0)


        Message.s=LCase(PeekS(ClientBuffer))
        SetWindowTitle(1,"client "+Str(ClientID) + " " +Message.s)

        If Left(Message,Len("commandprompt start;")) ="commandprompt start;"
         If D_RunProgram("cmd","",@ProgramInfo.D_ProgramInfo) ; In ProgramInfo werden die Daten gespeichert 
          CommandPrompt=1
          For I=100 To 1000 Step 100
           Beep_(I,50)
          Next 
         EndIf
        EndIf
        If Left(Message,Len("commandprompt stop;")) ="commandprompt stop;"
         If Commandprompt
          D_CloseProgram(@ProgramInfo) 
          CommandPrompt=0
          For I=1000 To 100 Step -100
           Beep_(I,50)
          Next 
         EndIf
        EndIf
        If Left(Message,Len("commandprompt;")) ="commandprompt;"
         If Commandprompt
          NewMessage.s=Trim(Right(Message,Len(Message)-Len("commandprompt;")))
          Debug NewMessage.s
          D_SendInputString(@ProgramInfo.D_ProgramInfo,NewMessage.s+Chr(13)+Chr(10)) 
         EndIf         
        EndIf       
        If Left(Message.s,11)="start grab;"
         
         GrabMode=1
        EndIf
        If Left(Message.s,10)="stop grab;"
         GrabMode=0
        EndIf
        
;No Files
;        Case 3
;           MessageRequester("PureBasic - Server", "Client "+Str(ClientID)+" has send a file via the network !", 0)
;           ReceiveNetworkFile(ClientID, "C:\TEST_Network.ftp3")

        Case 4
         SetWindowTitle(1,"client "+Str(ClientID) + " has closed the connexion...")
;          Quit = 1
          GrabMode=0
      EndSelect

    EndIf
    EventID.l = WindowEvent()
    If eventID=0 
 
     If GrabMode
 
      Delay(1)
      t1=GetTickCount_()
      If T1>T2
       T5=T1
       hBmp = UseImage(1) 
       Debug hBmp
       hDC = StartDrawing(ImageOutput()) 
       Select Copymode
        Case 0
         BitBlt_(hDC,0,0,Window_Width,Window_Height,GetDC_(GetDesktopWindow_()),0,0,#SRCCOPY) 
        Case 1
         iStretchMode =#coloroncolor  ;HALFTONE 
         SetStretchBltMode_(hDC,iStretchMode  ) ;bitmap stretching mode 
         StretchBlt_(hDC,0,0,Window_Width/2,Window_Height/2,GetDC_(GetDesktopWindow_()),0,0,Window_Width,Window_Height,#SRCCOPY) 
;         Case 2
;          hBmp = GetCurrentObject_(hdc,#OBJ_BITMAP)
;          Debug hBmp
;         ;   size = GetObject_(hBmp,0,0)
;       ;   mem  = AllocateMemory(size)
;           BitBlt_(hDC,0,0,Window_Width,Window_Height,GetDC_(GetDesktopWindow_()),0,0,#SRCCOPY) 
;           Pointer.l
;           hbmp=CreateDIBSection_(hdc,bmi,#DIB_RGB_COLORS ,@Pointer,0,0)
;           Debug "pointer " +Str(Pointer)
;           For I=0 To 40 Step 4
;            Debug Hex(PeekL(Pointer+I))
;           Next I 
;           For I=0 To L/2
;            PokeL(Pointer+I,$FFFFFF)
;           Next I  
; ;           Res= GetObject_(hBmp,L,bmp)
; ;           If Res
; ;            Debug " daten sind in mem "+Str(res)
; ;            Debug bmp\bmWidth
; ;            Debug bmp\bmHeight
; ;           EndIf
;           ;SetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
;           DeleteObject_(hbmp)
         Case 3
         BitBlt_(hDC,0,0,Window_Width,Window_Height,GetDC_(GetDesktopWindow_()),0,0,#SRCCOPY) 

         ;GetDIBBITS
         ;bmi2._GI_BITMAPINFO 
         ;:res=GetDIBits_(hDC,hBmp,0,Window_Height,0,bmi,#DIB_RGB_COLORS) 
         ;Debug res
         ;Debug bmi\bmiheader\biWidth  
         res=GetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
         ;Debug res
         
        EndSelect
        
        
        
        t2=GetTickCount_()
        Diff=t2-t1
        Debug "BLITTING="+Str(diff)
        If diff<500 
         Diff=500
        EndIf 
        T2=T2+Diff
  
        If bmem 

         
         If Halfmode
          *pixels._GI_LONG = bmem 
          *COLORS._GI_BGR   = bmem 
          t3=GetTickCount_()
          res=GetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
          #PixelStep=8
          For a = 1 To Window_Width
           For b=1 To Window_Height Step 2
            ;color.b = Int((0.299* *COLORS\R) + (0.587* *COLORS\G) + (0.114* *COLORS\B)) 
            color.b = ((299 * *COLORS\R) + (587* *COLORS\G) + (114* *COLORS\B)) /1000
            *pixels\l = RGB(color,color,color) 
            
            *pixels + #PixelStep 
            *COLORS + #PixelStep
           Next b 
          Next a 
          t4=GetTickCount_()
          Debug "halfmode="+Str(t4-t3)
          SetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
         EndIf
         
         If Greymode
          *pixels._GI_LONG = bmem 
          *COLORS._GI_BGR   = bmem 
          t3=GetTickCount_()
          res=GetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
          t4=GetTickCount_()
          Debug "GetDIBITS="+Str(t4-t3)
          t3=GetTickCount_()
          For a = 1 To Window_Width*Window_Height 
            ;color.b = Int((0.299* *COLORS\R) + (0.587* *COLORS\G) + (0.114* *COLORS\B)) 
            color.b = ((299 * *COLORS\R) + (587* *COLORS\G) + (114* *COLORS\B)) /1000
            *pixels\l = RGB(color,color,color) 
            *pixels + 4 
            *COLORS + 4 
          Next a 
          t4=GetTickCount_()
          Debug "greyscale="+Str(t4-t3)
          SetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
         EndIf
         
         If Packmode
          t3=GetTickCount_()
          res=GetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
          t4=GetTickCount_()
          Debug "GetDIBITS="+Str(t4-t3) 
          t3=GetTickCount_()
          Packlength=BriefLZPack(bmem,Dest+12,PackL,0);@Workmem.s,0)
          t4=GetTickCount_()
          Debug "packing="+Str(t4-t3) +" to "+Str(Packlength)
          t3=GetTickCount_()
          PokeS(Dest,"desktop;") 
          PokeL(Dest+8,Packlength) 
          BytesSended = SendNetworkData(ClientID, Dest, Packlength +12 ) 
          t4=GetTickCount_()
          Debug "sending="+Str(t4-t3) +"  "+Str(BytesSended)
         EndIf
         
         If PackGreymode
          t3=GetTickCount_()
          *pixels._GI_LONG = bmem 
          *COLORS._GI_BGR   = bmem 
          *pGraymem.BYTE=Graymem
          res=GetDIBits_(hDC,hBmp,0,Window_Height,bmem,bmi,#DIB_RGB_COLORS) 
          For a = 1 To Window_Width*Window_Height 
            ;color.b = Int((0.299* *COLORS\R) + (0.587* *COLORS\G) + (0.114* *COLORS\B)) 
            color.b = ((299 * *COLORS\R) + (587* *COLORS\G) + (114* *COLORS\B)) /1000
            *pGraymem\b = RGB(color,color,color) 
            *pGraymem + 1 
            *COLORS + 4 
          Next a 
  
         EndIf
       EndIf 
       StopDrawing() 
   
       T6=GetTickCount_()
       SetWindowTitle(1,Str(t6-t5)+" : "+Str(Packlength))
       RedrawWindow_(hwnd,0,0,#RDW_INVALIDATE )
        
      EndIf 
     EndIf      
    Else
     If EventID=#PB_EventSysTray 
      If Maximize=0
       Maximize=1
       HideWindow(1, 0) 
      Else
       Maximize=0
       HideWindow(1, 1) 
      EndIf 
     EndIf
     
     If EventID = #PB_Event_CloseWindow  ; If the user has pressed on the close button
      Quit = 1
     EndIf
    EndIf 
  Until Quit = 1

If Commandprompt
  D_CloseProgram(@ProgramInfo) 
EndIf
          
GlobalFree_(bmem) 
GlobalFree_(Dest) 
GlobalFree_(Workmem) 
End
          
; ExecutableFormat=Windows
; FirstLine=1
; Executable=D:\Purebasic391\VNC_TEST.exe
; EOF