;----------------------------------------
;----------------------------------------
;  Hide a Window from the Taskbar
;----------------------------------------
;----------------------------------------

#HideFromTaskbar_QueryInterface =  0
#HideFromTaskbar_AddRef         =  4
#HideFromTaskbar_Release        =  8
#HideFromTaskbar_HrInit         = 12
#HideFromTaskbar_AddTab         = 16
#HideFromTaskbar_DeleteTab      = 20
#HideFromTaskbar_ActivateTab    = 24
#HideFromTaskbar_SetActiveAlt   = 28

;
; Hide or UnHide a Window from the Windows Taskbar
;
; STATES: #FALSE (0)    =  Show Window on Taskbar
;         #TRUE  (<>0)  =  Hide Window on Taskbar
;
Procedure HideFromTaskbar(WINDOW, STATE)
   Shared proc_HideFromTaskbar_Object
   If STATE = 0
      CallCOM(#HideFromTaskbar_AddTab,proc_HideFromTaskbar_Object,WINDOW)     ; Show on Taskbar
   Else
      CallCOM(#HideFromTaskbar_DeleteTab,proc_HideFromTaskbar_Object,WINDOW)  ; Delete TAB for hWnd from Taskbar
   EndIf
EndProcedure

;
; Call at begin of program
;
Procedure InitHideFromTaskbar()
   Shared proc_HideFromTaskbar_Object
      CoInitialize_(0)
      CoCreateInstance_(?CLSID_TaskbarList,0,1,?IID_ITaskbarList,@proc_HideFromTaskbar_Object)
      CallCOM(#HideFromTaskbar_HrInit,proc_HideFromTaskbar_Object)            ; Init the Object
EndProcedure

;
; Call at end of program
;
Procedure EndHideFromTaskbar()
   Shared proc_HideFromTaskbar_Object
   CallCOM(#HideFromTaskbar_RELEASE,proc_HideFromTaskbar_Object)
   CoUnInitialize_()
EndProcedure


DataSection
  CLSID_TaskbarList:
    Data.l $56FDF344
    Data.w $FD6D,$11D0
    Data.b $95,$8A,$00,$60,$97,$C9,$A0,$90
  IID_ITaskbarList:
    Data.l $56fdf342
    Data.w $FD6D,$11D0
    Data.b $95,$8A,$00,$60,$97,$C9,$A0,$90
EndDataSection
;----------------------------------------
;----------------------------------------
;  end include file
;----------------------------------------
;----------------------------------------
