;====================================================================================================== 
;                                 Database variables 
;====================================================================================================== 

#DatabaseNumber = 1 

dbOpen.l = 0 

;====================================================================================================== 
;                                 ; Form designer created variables 
;====================================================================================================== 

Enumeration 1 
  #Window_mdbdetails 
EndEnumeration 

#WindowIndex = #PB_Compiler_EnumerationValue 

Enumeration 1 
  #Gadget_mdbdetails_tableframe 
  #Gadget_mdbdetails_tables 
  #Gadget_mdbdetails_returnframe 
  #Gadget_mdbdetails_lnumcol 
  #Gadget_mdbdetails_numcol 
  #Gadget_mdbdetails_lsearch 
  #Gadget_mdbdetails_search 
  #Gadget_mdbdetails_lnumrow 
  #Gadget_mdbdetails_numrow 
  #Gadget_mdbdetails_fdname 
  #Gadget_mdbdetails_ldname 
  #Gadget_mdbdetails_dname 
  #Gadget_mdbdetails_bgetdname 
  #Gadget_mdbdetails_cframe 
  #Gadget_mdbdetails_bsave 
  #Gadget_mdbdetails_bget 
  #Gadget_mdbdetails_bexit 
  #Gadget_mdbdetails_dataframe 
  #Gadget_mdbdetails_data 
  #Gadget_mdbdetails_eframe 
  #Gadget_mdbdetails_ebox 
EndEnumeration 

#GadgetIndex = #PB_Compiler_EnumerationValue 

;====================================================================================================== 
;                                 ; Create a temporary list to hold the number of tables in the database 
;====================================================================================================== 

NewList Tables.s() 

;====================================================================================================== 
;                                 ; Try to initialise the database environment 
;====================================================================================================== 

If InitDatabase() = 0 
  End 
EndIf 

;====================================================================================================== 
;                                 Main program window 
;====================================================================================================== 

Procedure.l Window_mdbdetails() 
  If OpenWindow(#Window_mdbdetails,50,70,800,425,#PB_Window_ScreenCentered|#PB_Window_Invisible,"Get details and data from an Ms-Access (MDB) database file") 
    If CreateGadgetList(WindowID(#Window_mdbdetails)) 
      Frame3DGadget(#Gadget_mdbdetails_tableframe,5,5,320,165,"") 
      ListIconGadget(#Gadget_mdbdetails_tables,10,15,310,150,"Table name",140,#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection) 
        AddGadgetColumn(#Gadget_mdbdetails_tables,1,"Table type",140) 
      Frame3DGadget(#Gadget_mdbdetails_returnframe,330,5,465,70,"") 
      TextGadget(#Gadget_mdbdetails_lnumcol,340,25,180,15,"Number of columns in selected table") 
      StringGadget(#Gadget_mdbdetails_numcol,520,20,80,20,"",#PB_String_ReadOnly) 
      TextGadget(#Gadget_mdbdetails_lsearch,610,25,175,15,"Type in a string to search for below",#PB_Text_Center) 
      StringGadget(#Gadget_mdbdetails_search,610,45,175,20,"") 
      TextGadget(#Gadget_mdbdetails_lnumrow,340,50,180,15,"Number of rows in selected table") 
      StringGadget(#Gadget_mdbdetails_numrow,520,45,80,20,"",#PB_String_ReadOnly) 
      Frame3DGadget(#Gadget_mdbdetails_fdname,330,75,465,45,"") 
      TextGadget(#Gadget_mdbdetails_ldname,340,95,85,15,"Database name") 
      StringGadget(#Gadget_mdbdetails_dname,425,90,330,20,"",#PB_String_ReadOnly) 
      ButtonGadget(#Gadget_mdbdetails_bgetdname,760,90,25,20,"...") 
        SetGadgetFont(#Gadget_mdbdetails_bgetdname,LoadFont(#Gadget_mdbdetails_bgetdname,"Arial",9,256)) 
      Frame3DGadget(#Gadget_mdbdetails_cframe,330,120,465,50,"") 
      ButtonGadget(#Gadget_mdbdetails_bsave,400,135,60,25,"Save data") 
      ButtonGadget(#Gadget_mdbdetails_bget,340,135,60,25,"Get data") 
      ButtonGadget(#Gadget_mdbdetails_bexit,725,135,60,25,"Exit") 
      Frame3DGadget(#Gadget_mdbdetails_dataframe,5,170,790,215,"") 
      EditorGadget(#Gadget_mdbdetails_data,10,180,780,200) 
      Frame3DGadget(#Gadget_mdbdetails_eframe,5,385,790,35,"") 
      StringGadget(#Gadget_mdbdetails_ebox,10,395,780,20,"",#PB_String_ReadOnly) 
      HideWindow(#Window_mdbdetails,0) 
      ProcedureReturn WindowID() 
    EndIf 
  EndIf 
EndProcedure 

;====================================================================================================== 
;                                 Main program handler 
;====================================================================================================== 

If Window_mdbdetails() 

  Quit = 0 
   
  Repeat 
   
    EventID = WaitWindowEvent() 
     
    Select EventID 
     
      Case #PB_Event_CloseWindow 
       
        If EventWindowID() = #Window_mdbdetails 
          Gosub ExitProgram 
        EndIf 
         
      Case #PB_Event_Gadget 
       
        Select EventGadgetID() 
         
          Case #Gadget_mdbdetails_tables      : Gosub TableActions  ; Check for clicks in the table list 
          Case #Gadget_mdbdetails_bget        : Gosub DumpData      ; Dump data to the data box 
          Case #Gadget_mdbdetails_bgetdname   : Gosub OpenDatabase  ; Open a new database file 
          Case #Gadget_mdbdetails_bsave       : Gosub SaveData      ; Save the dumped data to a disk file 
          Case #Gadget_mdbdetails_bexit       : Gosub ExitProgram   ; Exit the program now 
           
        EndSelect 
         
    EndSelect 
     
  Until Quit 
   
  CloseWindow(#Window_mdbdetails) 
   
EndIf 

End 

;====================================================================================================== 
TableActions:                     ; Check for events happening in the table list 
;====================================================================================================== 

  Select EventType() 
   
    Case #PB_EventType_LeftDoubleClick 
     
      Gosub GetColsAndRows 
       
  EndSelect 
      
Return 

;====================================================================================================== 
OpenDatabase:                     ; Open a new database file 
;====================================================================================================== 

  If dbOpen 
   
    CloseDatabase(#DatabaseNumber) 
     
    dbOpen = 0 
     
  EndIf 
   
  Filename.s = OpenFileRequester("Choose a database file", "C:\", "Microsoft Access |*.mdb", 0) 
   
  If Filename.s = "" 
   
    SetGadgetText(#Gadget_mdbdetails_ebox, "You won't get anywhere by leaving the filename blank") 
     
  Else 
   
    dbOpen.l = 1 
     
    SetGadgetText(#Gadget_mdbdetails_dname, Filename.s) 

    ClearGadgetItemList(#Gadget_mdbdetails_tables) 
     
    Result = MakeConnection("", "Server=SomeServer; Description=Description For PurebasicODBC;DSN=PureBasic_DSN;DBQ=" + Filename.s + ";UID=;PWD=;") 
    Result = OpenDatabase(#DatabaseNumber, "PureBasic_DSN", "", "") 
     
    If Result  
     
      ExamineTables(#DatabaseNumber) 
       
      While NextTable() <> 0 
       
        If LCase(GetTableType()) = "table" 
         
          AddGadgetItem(#Gadget_mdbdetails_tables, -1, GetTableName() + Chr(10) + GetTableType()) 
          AddElement(Tables()) 
          Tables() = GetTableName()  
           
        EndIf  
         
      Wend 
       
      CloseDatabase(#DatabaseNumber) 
      OpenDatabase(#DatabaseNumber, "PureBasic_DSN", "", "") 
       
      dbOpen.l = 1 
       
    EndIf 

  EndIf 
   
Return 

;====================================================================================================== 
SaveData:                         ; Save the data found from the tables 
;====================================================================================================== 

  If dbOpen.l 
   
    NumItems.l = CountGadgetItems(#Gadget_mdbdetails_data)  ; How many dumped items in the data box? 
     
    DumpFile.s = SaveFileRequester("File to save to", "C:\DumpFile.txt", "Text (*.txt)|*.txt;*.asc", 0) 
     
    If DumpFile.s = "" 
     
      SetGadgetText(#Gadget_mdbdetails_ebox, "User cancelled, nothing to save to") 
       
      Return 
       
    EndIf 
     
    If CreateFile(2, DumpFile.s) <> 0 
     
      For ItemStart.l = 0 To NumItems - 1 
       
        WriteStringN(GetGadgetItemText(#Gadget_mdbdetails_data, ItemStart.l, 0)) 
         
      Next ItemStart 
       
      CloseFile(2) 
       
    EndIf 
     
  EndIf 
   
Return 

;====================================================================================================== 
ExitProgram:                      ; Exit the program now and do any cleanups necessary 
;====================================================================================================== 
   
  Quit = 1 

Return 

;====================================================================================================== 
GetColsAndRows:                   ; Get the number of rows and columns in the open database 
;====================================================================================================== 

  TableName.s = GetGadgetItemText(#Gadget_mdbdetails_tables, GetGadgetState(#Gadget_mdbdetails_tables), 0) 

  If DatabaseQuery("SELECT * FROM [" + TableName.s + "]") 
   
    SetGadgetText(#Gadget_mdbdetails_numcol, Str(DatabaseColumns()))  ; How many columns/fields (across) in the table 
     
  Else 
   
    SetGadgetText(#Gadget_mdbdetails_ebox, "There was a problem with the query") 
     
  EndIf 
   
  FieldName.s = DatabaseColumnName(0) 
   
  If DatabaseQuery("SELECT Count(" + FieldName.s + ") AS last_rec FROM " + TableName.s + ";") ; How many rows down 
   
    While NextDatabaseRow() 
     
      SetGadgetText(#Gadget_mdbdetails_numrow, Str(GetDatabaseLong(0))) 
       
    Wend 
     
  EndIf 
   
Return 

;====================================================================================================== 
DumpData:                         ; Dump data to the user data box based on search string or blank entry 
;====================================================================================================== 

  If dbOpen                                                          ; Only do this if database is open else error 
   
    ClearGadgetItemList(#Gadget_mdbdetails_data)                     ; Clear the previous data dump 
     
    AvaliableCols.l  = Val(GetGadgetText(#Gadget_mdbdetails_numcol)) ; Get available columns 
     
    If AvaliableCols.l = 0                                           ; No columns int able so return 
     
      SetGadgetText(#Gadget_mdbdetails_ebox, "No columns in this table, nothing to do") 
       
      Return 
       
    EndIf 
     
    SearchString.s = LCase(GetGadgetText(#Gadget_mdbdetails_search)) ; Get the user's search string 
     
    If DatabaseQuery("SELECT * FROM [" + TableName.s + "];") 
     
      While NextDatabaseRow() 
       
        For ColStart = 0 To AvaliableCols.l - 1 
         
          DumpString.s + GetDatabaseString(ColStart.l) + ";" 
           
        Next ColStart 
         
        If SearchString.s = "" 
         
          AddGadgetItem(#Gadget_mdbdetails_data, -1, DumpString.s) 
           
        ElseIf SearchString.s <> "" 
         
          If FindString(LCase(DumpString.s), SearchString.s, 1) <> 0 
           
            AddGadgetItem(#Gadget_mdbdetails_data, -1, DumpString.s) 
             
          EndIf 
           
        EndIf 
         
        DumpString.s = "" 
         
      Wend 
       
    EndIf 
   
  EndIf   
   
Return 


; ExecutableFormat=Windows
; CursorPosition=308
; FirstLine=269
; EOF