; *********************************************************************
; 
; Purpose: Demo code showing how to create a database and index. Also
;          shows how to open and close the database and index.
; 
; Paul Squires (2000-2003)
; 
; *********************************************************************
 
;Define the names of the database & index
    DBFname.s = "Cheetah.dbf"
    IDXname.s = "Cheetah.idx"

;Create the database
    AllFields.s = "CUSTID,C,7,0;CUSTNAME,C,35,0;SALARY,N,14,2"
    xdbCreate(DBFName, AllFields)
 
;Open the database (database must be open prior To creating index)
    dbHandle.l = xdbOpen(DBFName, "") ; no encryption = ""
    Debug xdbAnyErrors() 

;Create the index (database must be open)
   IndexExpr.s = "UPPER(CUSTID)"   ;index is not case sensitive
   Duplicates.l = #XDBTRUE         ;allow duplicate customer ID's
    
   xdbCreateIndex(IDXName, dbHandle, IndexExpr, Duplicates)

;Open the index
   idxHandle.l = xdbOpenIndex(IDXname, dbHandle)
 
   msg.s = "DBFname: " + DBFname + Chr(10) + "dbHandle:" +  Str(dbHandle) + Chr(10) + Chr(10) + "IDXname: " + IDXname + Chr(10) + "idxHandle:" + Str(idxHandle)
   MessageRequester("Create DBF", msg, 0)

;Close the database And related index
 xdbClose(dbHandle)                                 
  

End











                                                                         
; ExecutableFormat=Windows
; CursorPosition=8
; FirstLine=1
; EOF