;Test file relations between 2 databases
;---------------------------------------

; Make it multi user
   xdbMultiUser(#XDBTRUE, 10, 500)

; Open the primary database
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  dbPrimary.l = xdbOpen("CustInfo.dbf", "")
  Debug xdbAnyErrors()
; Index on the CUSTID field if you haven't done so already
   xdbCreateIndex("CustID.idx", dbPrimary, "CUSTID", #XDBTRUE)

; Open the index
   idxPrimary = xdbOpenIndex("CustID.idx", dbPrimary)

; Reindex to make the index match the records in the database
   xdbReindexAll(dbPrimary, 0)

; Open the secondary database
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   dbSecondary = xdbOpen("Orders.dbf", "")

; Index on the CUSTID field if you haven't done so already
   xdbCreateIndex("O_CustID.idx", dbSecondary, "CUSTID", #XDBTRUE)

; Open the index
   idxSecondary = xdbOpenIndex("O_CustID.idx", dbSecondary)

; Reindex to make the index match the records in the database
   xdbReindexAll(dbSecondary, 0)
; ----------------------------------------------------------------------------   

; process each Customer Record and match it to a Order record.
; the index of the primary database is used so each customer ID is retrieved
; in numerical sequence.
          
   xdbMoveFirst(dbPrimary, idxPrimary)
Repeat
   ;the record in the primary database should now be loaded.
   
   ;get the customer ID
   CustID.s = xdbFieldValue(dbPrimary, "CUSTID", 0)
   
   LastName.s = xdbFieldValue(dbPrimary, "LAST", 0)
   
        ;use the CUSTID$ from the primary database to find the data in the
        ;secondary database
        If xdbSeek(dbSecondary, idxSecondary, CustID.s)
           ;exact match - there is now a link between the two databases
           ;process the primary and secondary database however you want.
           
           OrderID.s = xdbFieldValue(dbSecondary, "ORDERID", 0)
           dat.s = xdbDToS(xdbFieldValue(dbSecondary, "DATE", 0))
           
           total.s = xdbFieldValue(dbSecondary, "TOTAL", 0)
           emp.s = xdbFieldValue(dbSecondary, "EMPLID", 0)
           
           msg.s = " " + "LastName  " + "Order #            Date            Total         Empl#" + Chr(10)
           msg.s = msg + "  " + UCase(LastName)  + "     " + OrderID + "           " + dat + "      " + total + "        " +  emp
           MessageRequester("", msg, 0)
           
        EndIf
            ; --------------------------------------------------------------
            ; You could even use xdbSeekNext to find additional matching
            ; customer orders (one-TO-many relationship)
            ; you could put the xdbSeekNext into another loop to find all the
            ; matching orders.
            ; ---------------------------------------------------------------
        ; get the next record from the primary database
        xdbMoveNext(dbPrimary, idxPrimary)


Until xdbEOF(dbPrimary)
;locknum = xdbSetEditLock(dbHandle, 2

; Close the datbases And indexes
   xdbClose(dbPrimary)
   xdbClose(dbSecondary)

; Close the database And related index
   xdbClose(dbHandle)                                 

End


; ExecutableFormat=Windows
; CursorPosition=83
; FirstLine=41
; EOF