;PB Irrlicht Wrapper Functions
;Copyright 2005 DracSoft


DataSection
 PB_Irrlicht_dll:
 IncludeBinary "PB_Irrlicht.dll_UPX"
EndDataSection

;DEBUG INFO
; ProcedureCDLL ErrorHandler()
  ; MessageRequester("Error","Line: " + Str(GetErrorLineNR()))
  ; End
; EndProcedure
;OnErrorGosub(@ErrorHandler())


;*** ENUMERATIONS ***
Enumeration ;DRIVER TYPES
  #I3D_DRIVER_NULL
  #I3D_DRIVER_SOFTWARE
  #I3D_DRIVER_DIRECTX8
  #I3D_DRIVER_DIRECTX9
  #I3D_DRIVER_OPENGL
EndEnumeration

Enumeration ;MATERIAL FLAGS
  #I3D_MATERIALFLAG_WIREFRAME
  #I3D_MATERIALFLAG_GOURAUD_SHADING
  #I3D_MATERIALFLAG_LIGHTING
  #I3D_MATERIALFLAG_ZBUFFER
 #I3D_MATERIALFLAG_ZWRITE_ENABLE
 #I3D_MATERIALFLAG_BACK_FACE_CULLING
 #I3D_MATERIALFLAG_BILINEAR_FILTER
  #I3D_MATERIALFLAG_TRILINEAR_FILTER
  #I3D_MATERIALFLAG_FOG_ENABLE
  #I3D_MATERIALFLAG_MATERIAL_FLAG_COUNT   
EndEnumeration

Enumeration ;MATERIAL TYPES
  ; Standard solid material. Only first texture is used, which is
  ; supposed To be the diffuse material.
  #I3D_MATERIALTYPE_SOLID   
  
  ; solid material with 2 texture layers. the second is blended onto the
  ; first using the alpha value of the vertex colors.
  ; This material is currently not implemented in OpenGL, but it
  ; works with DirectX.
  #I3D_MATERIALTYPE_SOLID_2_LAYER
  
  ; material type with Standard lightmap technique: 
  ; There should be 2 textures: the first texture layer is a diffuse map,
  ; the second is a light map. vertex light is ignored.
  #I3D_MATERIALTYPE_LIGHTMAP
  
  ; material type with lightmap technique like EMT_LIGHTMAP, but
  ; lightmap And diffuse texture are not modulated, but added instead.
  #I3D_MATERIALTYPE_LIGHTMAP_ADD
  
  ; material type with Standard lightmap technique: 
  ; There should be 2 textures: the first texture layer is a diffuse map,
  ; the second is a light map. vertex light is ignored.
  ; the texture colors are effectively multiplyied by 2 For brightening.
  ; like known in DirectX as D3DTOP_MODULATE2X.
  #I3D_MATERIALTYPE_LIGHTMAP_M2
    
  ; material type with Standard lightmap technique: 
  ; There should be 2 textures: the first texture layer is a diffuse map,
  ; the second is a light map. vertex light is ignored.
  ; the texture colors are effectively multiplyied by 4 For brightening.
  ; like known in DirectX as D3DTOP_MODULATE4X.
  #I3D_MATERIALTYPE_LIGHTMAP_M4
  
  ; like EMT_LIGHTMAP, but also supports dynamic lighting.
  #I3D_MATERIALTYPE_LIGHTMAP_LIGHTING
  
  ; like EMT_LIGHTMAP_M2, but also supports dynamic lighting.
  #I3D_MATERIALTYPE_LIGHTMAP_LIGHTING_M2
  
  ; like EMT_LIGHTMAP_4, but also supports dynamic lighting.
  #I3D_MATERIALTYPE_LIGHTMAP_LIGHTING_M4
  
  ; Makes the material look like it was reflection the environment
  ; around it. To make This possible, a texture called 'sphere map'
  ; is used, which must be set as Texture1.
  #I3D_MATERIALTYPE_SPHERE_MAP
  
  ; a reflecting material with an 
  ; optional additional non reflecting texture layer. the reflection
  ; map should be set as texture 1.
  ; Please note that This material type is currently not 100% implemented
  ; in OpenGL. it works in DirectX8.
  #I3D_MATERIALTYPE_REFLECTION_2_LAYER
  
  ; a transparent material. Only the first texture is used.
  ; the new color is calculated by simply adding the source color And
  ; the dest color. This means If For example a billboard using a texture with 
  ; black background And a red circle on it is drawed with This material, the
  ; result is that Only the red circle will be drawn a little bit transparent,
  ; And everything which was black is 100% transparent And not visible.
  ; This material type is useful For e.g. particle effects.
  #I3D_MATERIALTYPE_TRANSPARENT_ADD_COLOR
            
  ; Makes the material transparent based on the texture alpha channel.
  ; Only first texture is used. Please note that This material is currenly
  ; not implemented.
  #I3D_MATERIALTYPE_TRANSPARENT_ALPHA_CHANNEL 
  
  ; Makes the material transparent based on the vertex alpha value.
  #I3D_MATERIALTYPE_TRANSPARENT_VERTEX_ALPHA
 
  ; a transparent reflecting material with an 
  ; optional additional non reflecting texture layer. the reflection
  ; map should be set as texture 1. the transparency depends on the
  ; alpha value in the vertex colors. a texture which will not reflect
  ; can be set als texture 2.
  ; Please note that This material type is currently not 100% implemented
  ; in OpenGL. it works in DirectX8.
  #I3D_MATERIALTYPE_TRANSPARENT_REFLECTION_2_LAYER
EndEnumeration

Enumeration ;GUI EVENT TYPES
  #I3D_GUIEVENT_ELEMENT_FOCUS_LOST ; A gui element has lost its focus.
  #I3D_GUIEVENT_ELEMENT_HOVERED ; A gui element was hovered.
  #I3D_GUIEVENT_ELEMENT_LEFT ; A hovered gui element was left
  #I3D_GUIEVENT_BUTTON_CLICKED ; A button was clicked.
  #I3D_GUIEVENT_SCROLL_BAR_CHANGED ; A scrollbar has changed its position.
  #I3D_GUIEVENT_CHECKBOX_CHANGED ; A checkbox has changed its check state.
  #I3D_GUIEVENT_LISTBOX_CHANGED ; A new item in A listbox was seleted.
  #I3D_GUIEVENT_LISTBOX_SELECTED_AGAIN ; An item in the listbox was selected, which was already selected.
  #I3D_GUIEVENT_FILE_SELECTED ; A file has been selected in the file open dialog
  #I3D_GUIEVENT_FILE_CHOOSE_DIALOG_CANCELLED ; A file open dialog has been closed without choosing A file
  #I3D_GUIEVENT_MESSAGEBOX_YES ; 'Yes' was clicked on A messagebox
  #I3D_GUIEVENT_MESSAGEBOX_NO ; 'No' was clicked on A messagebox
  #I3D_GUIEVENT_MESSAGEBOX_OK ; 'OK' was clicked on A messagebox
  #I3D_GUIEVENT_MESSAGEBOX_CANCEL ; 'Cancel' was clicked on A messagebox
  #I3D_GUIEVENT_EDITBOX_ENTER ; in An editbox was pressed 'ENTER'
  #I3D_GUIEVENT_TAB_CHANGED ; the tab was changed in An tab control
  #I3D_GUIEVENT_MENU_ITEM_SELECTED ; A menu item was selected in a (context) menu
EndEnumeration

Enumeration ;GUI MSGBOX TYPES
 #I3D_GUI_MSGBOX_OK = 1
  #I3D_GUI_MSGBOX_CANCEL = 2
  #I3D_GUI_MSGBOX_YES = 4
  #I3D_GUI_MSGBOX_NO = 8
EndEnumeration


;*** ENGINE STRUCTURES ***
Structure I3D_NODEDATA
  xPos.f
  yPos.f
  zPos.f
  xRot.f
  yRot.f
  zRot.f
EndStructure

Structure I3D_GUI_EVENT
  guiID.l
  eventType.l
EndStructure

Structure I3D_FUNCTION_POINTERS
  INITIALIZE3D.l
  ISRUNNING.l
  GETFPS.l
  BEGINRENDER.l
  ENDRENDER.l
  CLOSE3D.l
  DOCLEANUP.l
  SETBACKGROUNDCOLOR.l
  SETSHADOWCOLOR.l
  RENDERGUI.l
  RENDERSCENE.l
  SETWINDOWCAPTION.l
  DRAW2DTEXT.l
  GUI_SETFONT.l
  GUI_CREATEEDITBOX.l
  GUI_CREATEBUTTON.l
  GUI_CREATESTATICTEXT.l
  GUI_CREATEMESSAGEBOX.l
  LOADMESH.l
  LOADTEXTURE.l
  ADDANIMATEDNODE.l
  ADDDYNAMICLIGHT.l
  NODE_SETTEXTURE.l
  NODE_SETMATERIALTYPE.l
  NODE_SETMATERIALFLAG.l
  CAMERA_SETPOSITION.l
  CAMERA_POINTATNODE.l
  CAMERA_SETROTATION.l
  NODE_SETROTATION.l
  NODE_SETPOSITION.l
  NODE_GETDATA.l
  GETENGINEVERSION.l
EndStructure

;*** ENGINE GLOBALS ***
Global i3D_Functions.I3D_FUNCTION_POINTERS

; ;*** BASE ENGINE FUNCTIONS ***
; ProcedureDLL GetI3DFunctionPointers(i3D_Library.l)
;   If IsLibrary(i3D_Library)
;     ExamineLibraryFunctions(i3D_Library)
;     Repeat
;       Select LibraryFunctionName()
;         
;         Case "pb_Initialize3D"
;           i3D_Functions\INITIALIZE3D=LibraryFunctionAddress()
;         Case "pb_Running"
;           i3D_Functions\ISRUNNING=LibraryFunctionAddress()
;         Case "pb_GetFPS"
;           i3D_Functions\GETFPS=LibraryFunctionAddress()
;         Case "pb_GetEngineVersion"
;           i3D_Functions\GETENGINEVERSION=LibraryFunctionAddress()
;         Case "pb_BeginRender"
;           i3D_Functions\BEGINRENDER=LibraryFunctionAddress()
;         Case "pb_EndRender"
;           i3D_Functions\ENDRENDER=LibraryFunctionAddress()
;         Case "pb_Close3D"
;           i3D_Functions\CLOSE3D=LibraryFunctionAddress()
;         Case "pb_DoCleanUp"
;           i3D_Functions\DOCLEANUP=LibraryFunctionAddress()
;         Case "pb_SetBackgroundColor"
;           i3D_Functions\SETBACKGROUNDCOLOR=LibraryFunctionAddress()
;         Case "pb_SetShadowColor"
;           i3D_Functions\SETSHADOWCOLOR=LibraryFunctionAddress()
;         Case "pb_DrawGUI"
;           i3D_Functions\RENDERGUI=LibraryFunctionAddress()
;         Case "pb_DrawScene"
;           i3D_Functions\RENDERSCENE=LibraryFunctionAddress()
;         Case "pb_SetWindowCaption"
;           i3D_Functions\SETWINDOWCAPTION=LibraryFunctionAddress()
;         Case "pb_Draw2DText"
;           i3D_Functions\DRAW2DTEXT=LibraryFunctionAddress()
;         Case "pb_GUI_SetFont"
;           i3D_Functions\GUI_SETFONT=LibraryFunctionAddress()
;         Case "pb_GUI_CreateEditBox"
;           i3D_Functions\GUI_CREATEEDITBOX=LibraryFunctionAddress()
;         Case "pb_GUI_CreateButton"
;           i3D_Functions\GUI_CREATEBUTTON=LibraryFunctionAddress()
;         Case "pb_GUI_CreateStaticText"
;           i3D_Functions\GUI_CREATESTATICTEXT=LibraryFunctionAddress()
;         Case "pb_GUI_CreateMessageBox"
;           i3D_Functions\GUI_CREATEMESSAGEBOX=LibraryFunctionAddress()
;         Case "pb_LoadMesh"
;           i3D_Functions\LOADMESH=LibraryFunctionAddress()
;         Case "pb_LoadTexture"
;           i3D_Functions\LOADTEXTURE=LibraryFunctionAddress()
;         Case "pb_CreateAnimatedNode"
;           i3D_Functions\ADDANIMATEDNODE=LibraryFunctionAddress()
;         Case "pb_CreateDynamicLight"
;           i3D_Functions\ADDDYNAMICLIGHT=LibraryFunctionAddress()
;         Case "pb_Node_SetTexture"
;           i3D_Functions\NODE_SETTEXTURE=LibraryFunctionAddress()
;         Case "pb_Node_SetMaterialFlag"
;           i3D_Functions\NODE_SETMATERIALFLAG=LibraryFunctionAddress()
;         Case "pb_Node_SetMaterialType"
;           i3D_Functions\NODE_SETMATERIALTYPE=LibraryFunctionAddress()
;         Case "pb_Camera_SetPosition"
;           i3D_Functions\CAMERA_SETPOSITION=LibraryFunctionAddress()
;         Case "pb_Camera_PointAtNode"
;           i3D_Functions\CAMERA_POINTATNODE=LibraryFunctionAddress()
;         Case "pb_Camera_SetRotation"
;           i3D_Functions\CAMERA_SETROTATION=LibraryFunctionAddress()
;         Case "pb_Node_SetRotation"
;           i3D_Functions\NODE_SETROTATION=LibraryFunctionAddress()
;         Case "pb_Node_SetPosition"
;           i3D_Functions\NODE_SETPOSITION=LibraryFunctionAddress()
;         Case "pb_Node_GetData"
;           i3D_Functions\NODE_GETDATA=LibraryFunctionAddress()
;         Default
;           MessageRequester("i3D Warning","Unhandled function: " + LibraryFunctionName())
;       EndSelect
;     Until NextLibraryFunction()=0
;   EndIf
; EndProcedure
; 
ProcedureDLL.l i3D_Initialize3D(driverType.l,width.l,height.l,bits.l,isFullscreen.l,isResizable.l,*CallBackProcedure) ; Starts the 3d engine. CallBackProcedure(id.l). YOU MUST CALL THIS BEFORE OTHER i3D FUNCTIONS
  ;i3D_Library.l=LoadLibrary_("./PB_Irrlicht.dll")
  i3D_Library.l=LoadLibraryM(?PB_Irrlicht_dll)
  If i3D_Library.l=0
   MessageRequester("Info","DLL NOT FOUND !",0)
   ProcedureReturn 0
  Else
   ;here , get the Functions
        i3D_Functions\INITIALIZE3D=GetProcAddressM(i3D_Library,"pb_Initialize3D")
        i3D_Functions\ISRUNNING=GetProcAddressM(i3D_Library, "pb_Running")
        i3D_Functions\GETFPS=GetProcAddressM(i3D_Library, "pb_GetFPS")
        i3D_Functions\GETENGINEVERSION=GetProcAddressM(i3D_Library, "pb_GetEngineVersion")
        i3D_Functions\BEGINRENDER=GetProcAddressM(i3D_Library, "pb_BeginRender")
        i3D_Functions\ENDRENDER=GetProcAddressM(i3D_Library, "pb_EndRender")
        i3D_Functions\CLOSE3D=GetProcAddressM(i3D_Library, "pb_Close3D")
        i3D_Functions\DOCLEANUP=GetProcAddressM(i3D_Library, "pb_DoCleanUp")
        i3D_Functions\SETBACKGROUNDCOLOR=GetProcAddressM(i3D_Library, "pb_SetBackgroundColor")
        i3D_Functions\SETSHADOWCOLOR=GetProcAddressM(i3D_Library, "pb_SetShadowColor")
        i3D_Functions\RENDERGUI=GetProcAddressM(i3D_Library, "pb_DrawGUI")
        i3D_Functions\RENDERSCENE=GetProcAddressM(i3D_Library, "pb_DrawScene")
        i3D_Functions\SETWINDOWCAPTION=GetProcAddressM(i3D_Library, "pb_SetWindowCaption")
        i3D_Functions\DRAW2DTEXT=GetProcAddressM(i3D_Library, "pb_Draw2DText")
        i3D_Functions\GUI_SETFONT=GetProcAddressM(i3D_Library, "pb_GUI_SetFont")
        i3D_Functions\GUI_CREATEEDITBOX=GetProcAddressM(i3D_Library, "pb_GUI_CreateEditBox")
        i3D_Functions\GUI_CREATEBUTTON=GetProcAddressM(i3D_Library, "pb_GUI_CreateButton")
        i3D_Functions\GUI_CREATESTATICTEXT=GetProcAddressM(i3D_Library, "pb_GUI_CreateStaticText")
        i3D_Functions\GUI_CREATEMESSAGEBOX=GetProcAddressM(i3D_Library, "pb_GUI_CreateMessageBox")
        i3D_Functions\LOADMESH=GetProcAddressM(i3D_Library, "pb_LoadMesh")
        i3D_Functions\LOADTEXTURE=GetProcAddressM(i3D_Library, "pb_LoadTexture")
        i3D_Functions\ADDANIMATEDNODE=GetProcAddressM(i3D_Library, "pb_CreateAnimatedNode")
        i3D_Functions\ADDDYNAMICLIGHT=GetProcAddressM(i3D_Library, "pb_CreateDynamicLight")
        i3D_Functions\NODE_SETTEXTURE=GetProcAddressM(i3D_Library, "pb_Node_SetTexture")
        i3D_Functions\NODE_SETMATERIALFLAG=GetProcAddressM(i3D_Library, "pb_Node_SetMaterialFlag")
        i3D_Functions\NODE_SETMATERIALTYPE=GetProcAddressM(i3D_Library, "pb_Node_SetMaterialType")
        i3D_Functions\CAMERA_SETPOSITION=GetProcAddressM(i3D_Library, "pb_Camera_SetPosition")
        i3D_Functions\CAMERA_POINTATNODE=GetProcAddressM(i3D_Library, "pb_Camera_PointAtNode")
        i3D_Functions\CAMERA_SETROTATION=GetProcAddressM(i3D_Library, "pb_Camera_SetRotation")
        i3D_Functions\NODE_SETROTATION=GetProcAddressM(i3D_Library, "pb_Node_SetRotation")
        i3D_Functions\NODE_SETPOSITION=GetProcAddressM(i3D_Library, "pb_Node_SetPosition")
        i3D_Functions\NODE_GETDATA=GetProcAddressM(i3D_Library, "pb_Node_GetData")

   ProcedureReturn CallCFunctionFast(i3D_Functions\INITIALIZE3D,driverType,width,height,bits,isFullscreen,isResizable,*CallBackProcedure)
  EndIf
EndProcedure

ProcedureDLL.l i3D_End()
 FreeLibraryM(i3D_Library)
EndProcedure



ProcedureDLL.l i3D_IsRunning() ; See if the 3d engine is running or crashed/stopped
  ProcedureReturn CallCFunctionFast(i3D_Functions\ISRUNNING)
EndProcedure

ProcedureDLL.l i3D_GetFPS() ; Get the current FPS
  ProcedureReturn CallCFunctionFast(i3D_Functions\GETFPS)
EndProcedure

ProcedureDLL.s i3D_GetEngineVersion() ; Get the current engine version
  ProcedureReturn PeekS(CallCFunctionFast(i3D_Functions\GETENGINEVERSION))
EndProcedure

ProcedureDLL.l i3D_BeginRender(isBackbuffer.l,isZbuffer.l) ; Open the engine for rendering
  ProcedureReturn CallCFunctionFast(i3D_Functions\BEGINRENDER,isBackbuffer,isZbuffer)
EndProcedure

ProcedureDLL.l i3D_EndRender() ; Open the engine for rendering
  ProcedureReturn CallCFunctionFast(i3D_Functions\ENDRENDER)
EndProcedure

ProcedureDLL i3D_Close3D() ; Close the 3D engine - follow this with DoCleanUp()
  CallCFunctionFast(i3D_Functions\CLOSE3D)
EndProcedure

ProcedureDLL i3D_DoCleanUp() ; Cleans up used memory
  CallCFunctionFast(i3D_Functions\DOCLEANUP)
EndProcedure

ProcedureDLL i3D_SetBackgroundColor(alpha.l,r.l,g.l,b.l) ; Set the render background color
  CallCFunctionFast(i3D_Functions\SETBACKGROUNDCOLOR,alpha,r,g,b)
EndProcedure

ProcedureDLL i3D_SetShadowColor(alpha.l,r.l,g.l,b.l) ; Set the shadow color
  CallCFunctionFast(i3D_Functions\SETSHADOWCOLOR,alpha,r,g,b)
EndProcedure

ProcedureDLL i3D_RenderGUI() ; Render the GUI to the screen after a BeginRender()
  CallCFunctionFast(i3D_Functions\RENDERGUI)
EndProcedure

ProcedureDLL i3D_RenderScene() ; Render the 3D data to the screen after a BeginRender()
  CallCFunctionFast(i3D_Functions\RENDERSCENE)
EndProcedure

ProcedureDLL i3D_SetWindowCaption(caption.s) ; Set the window caption
  CallCFunctionFast(i3D_Functions\SETWINDOWCAPTION,caption)
EndProcedure

ProcedureDLL i3D_Draw2DText(fontFile.s,x.l,y.l,text.s,colorA.l,colorR.l,colorG.l,colorB.l,isCentered.l) ; Directly render 2d text to the screen
  CallCFunctionFast(i3D_Functions\DRAW2DTEXT,fontFile,x,y,text,colorA,colorR,colorG,colorB,isCentered)
EndProcedure

;*** GUI FUNCTIONS ***
ProcedureDLL.l i3D_GUI_SetFont(fontPath.s) ; Create a button in the GUI and return it's ID
  ProcedureReturn CallCFunctionFast(i3D_Functions\GUI_SETFONT,fontPath)
EndProcedure

ProcedureDLL.l i3D_GUI_CreateEditBox(text.s,guiID.l,x.l,y.l,x2.l,y2.l,isBorder.l) ; Create an editbox in the GUI and return it's ID
  ProcedureReturn CallCFunctionFast(i3D_Functions\GUI_CREATEEDITBOX,text,guiID,x,y,x2,y2,isBorder)
EndProcedure

ProcedureDLL.l i3D_GUI_CreateButton(text.s,guiID.l,x.l,y.l,x2.l,y2.l) ; Create a button in the GUI and return it's ID
  ProcedureReturn CallCFunctionFast(i3D_Functions\GUI_CREATEBUTTON,text,guiID,x,y,x2,y2)
EndProcedure

ProcedureDLL.l i3D_GUI_CreateStaticText(text.s,guiID.l,x.l,y.l,x2.l,y2.l,isBorder.l,isWordWrap.l) ; Create a static textbox in the GUI and return it's ID
  ProcedureReturn CallCFunctionFast(i3D_Functions\GUI_CREATESTATICTEXT,text,guiID,x,y,x2,y2,isBorder,isWordWrap)
EndProcedure

ProcedureDLL.l i3D_GUI_CreateMessageBox(title.s,message.s,guiID.l,isModal.l,msgboxType.l) ; Create a static textbox in the GUI and return it's ID
  ProcedureReturn CallCFunctionFast(i3D_Functions\GUI_CREATEMESSAGEBOX,title,message,guiID,isModal,msgboxType)
EndProcedure

;*** 3D FUNCTIONS ***
ProcedureDLL.l i3D_LoadMesh(fileName.s) ; Preloads a mesh into memory
  ProcedureReturn CallCFunctionFast(i3D_Functions\LOADMESH,fileName)
EndProcedure

ProcedureDLL.l i3D_LoadTexture(fileName.s) ; Preloads a texture into memory
  ProcedureReturn CallCFunctionFast(i3D_Functions\LOADTEXTURE,fileName)
EndProcedure

ProcedureDLL.l i3D_AddAnimatedNode(fileName.s,meshID.l,scaleX.f,scaleY.f,scaleZ.f,isLighting.l) ; Adds an animated node from a mesh to a scene (use LoadMesh for preload)
  ProcedureReturn CallCFunctionFast(i3D_Functions\ADDANIMATEDNODE,fileName,meshID,scaleX,scaleY,scaleZ,isLighting)
EndProcedure

ProcedureDLL.l i3D_AddDynamicLight(lightID,x.f,y.f,z.f,colorA.l,colorR.l,colorG.l,colorB.l,radius.f) ; Adds a dynamic light to the scene
  ProcedureReturn CallCFunctionFast(i3D_Functions\ADDDYNAMICLIGHT,lightID,x,y,z,colorA,colorR,colorG,colorB,radius)
EndProcedure

ProcedureDLL i3D_Node_SetTexture(fileName.s,meshID.l,textureLayer.l) ; Textures an animated node with the supplied graphic
  CallCFunctionFast(i3D_Functions\NODE_SETTEXTURE,fileName,meshID,textureLayer)
EndProcedure

ProcedureDLL i3D_Node_SetMaterialFlag(meshID.l,flagType.l,flagValue.l) ; Sets a #i3D_MATERIALFLAG on a node
  CallCFunctionFast(i3D_Functions\NODE_SETMATERIALFLAG,meshID,flagType,flagValue)
EndProcedure

ProcedureDLL i3D_Node_SetMaterialType(meshID.l,matType.l) ; Sets a #i3D_MATERIALTYPE on a node
  CallCFunctionFast(i3D_Functions\NODE_SETMATERIALTYPE,meshID,matType)
EndProcedure

ProcedureDLL i3D_Camera_SetPosition(x.f,y.f,z.f) ; Sets the cameras absolute position
  CallCFunctionFast(i3D_Functions\CAMERA_SETPOSITION,x,y,z)
EndProcedure

ProcedureDLL i3D_Camera_PointAtNode(nodeID) ; Points the camera at a node's vector
  CallCFunctionFast(i3D_Functions\CAMERA_POINTATNODE,nodeID)
EndProcedure

ProcedureDLL i3D_Camera_SetRotation(x.f,y.f,z.f) ; Sets the absolute rotation of the camera
  CallCFunctionFast(i3D_Functions\CAMERA_SETROTATION,x,y,z)
EndProcedure

ProcedureDLL i3D_Node_SetRotation(nodeID.l,x.f,y.f,z.f) ; Sets the absolute rotation of a node
  CallCFunctionFast(i3D_Functions\NODE_SETROTATION,nodeID,x,y,z)
EndProcedure

ProcedureDLL i3D_Node_SetPosition(nodeID.l,x.f,y.f,z.f) ; Sets the absolute position of a node
  CallCFunctionFast(i3D_Functions\NODE_SETPOSITION,nodeID,x,y,z)
EndProcedure

ProcedureDLL i3D_Node_GetData(nodeID.l,*ReturnStruct.I3D_NODEDATA) ; Gets the nodes data in a structure
  CallCFunctionFast(i3D_Functions\NODE_GETDATA,nodeID,*ReturnStruct)
EndProcedure




;****************************
;PB_Irrlicht Test Application
;****************************
Global LastGuiID.l
Global LastGuiEvent.l

ProcedureCDLL EventHandler(*EventData.I3D_GUI_EVENT)
  LastGuiID=*EventData\guiID
  LastGuiEvent=*EventData\eventType
EndProcedure

Procedure HandleGUIEvent(guiID.l,eventType.l)
  If eventType=#I3D_GUIEVENT_BUTTON_CLICKED
    If guiID=102 
      i3D_Node_SetMaterialFlag(1,#I3D_MATERIALFLAG_WIREFRAME,1)
    EndIf
  EndIf
EndProcedure


;MAIN PROGRAM
ShipData.I3D_NODEDATA
PlanetData.I3D_NODEDATA
If i3D_Initialize3D(#I3D_DRIVER_OPENGL, 640,480,32,0,1,@EventHandler()) 
  ;set startup values
  InitKeyboard()
  i3D_SetShadowColor(255,0,0,0)
  i3D_SetBackgroundColor(155,90,90,90)
  i3D_SetWindowCaption("Test PB_Irrlicht - Version: " + i3D_GetEngineVersion())
  i3D_GUI_SetFont("./fontcourier.bmp")
  i3D_LoadMesh("./ship1.ms3d")
  i3D_LoadTexture("./ship1.bmp")
  i3D_AddAnimatedNode("./ship1.ms3d",1,1,1,1,1)
  i3D_AddAnimatedNode("./planet.ms3d",3,1,1,1,1)
  i3D_Node_SetMaterialType(1,#I3D_MATERIALTYPE_SPHERE_MAP)
  i3D_Node_SetTexture("./ship1.bmp",1,0) 
  i3D_AddDynamicLight(1,5,5,5,100,255,255,255,100)
  i3D_Camera_SetPosition(20,50,20)
  ;i3D_Node_AddDynamicShadow(1)
  
  ;create GUI
  EditBox1.l = i3D_GUI_CreateEditBox("Edit box sample",101,100,100,250,150,1)
  Button1.l = i3D_GUI_CreateButton("Wireframe",102,400,100,500,150)
  Static1.l = i3D_GUI_CreateStaticText("DLL loaded from Memory!",103,250,250,450,300,0,0)
  MsgBox.l = i3D_GUI_CreateMessageBox("Test MsgBox","Testing 1 2 3",104,1,#I3D_GUI_MSGBOX_OK + #I3D_GUI_MSGBOX_CANCEL)
  
  While i3D_IsRunning()
    i3D_Camera_PointAtNode(1)
    
    ;Start the rendering sequence - ORDER MATTERS
    i3D_BeginRender(1,1)
    
    ;Render to the screen 
    i3D_RenderScene()
    i3D_RenderGUI()
    
    ;Draw2DText must be done between beginrender and endrender, no other time
    i3D_Draw2DText("./fontcourier.bmp",10,10,"Hello and welcome to PB_Irrlicht by dracflamloc!",255,255,255,255,0)
    i3D_Draw2DText("./fontcourier.bmp",10,30,"http://www.dracsoft.com/",255,255,255,255,0)
    i3D_Draw2DText("./fontcourier.bmp",10,50,"X: " + Str(ShipData\xPos),255,255,255,255,0)
    i3D_Draw2DText("./fontcourier.bmp",10,70,"Z: " + Str(ShipData\zPos),255,255,255,255,0)
    i3D_Draw2DText("./fontcourier.bmp",10,90,"FPS: " + Str(i3D_GetFPS()),255,255,255,255,0)
    
    ;End the rendering sequence
    i3D_EndRender()
    
    ;update data and rotate object
    i3D_Node_GetData(1,@ShipData)
    i3D_Node_SetRotation(1,ShipData\xRot+0.05,ShipData\yRot+0.05,ShipData\zRot-0.05)
    i3D_Node_GetData(3,@PlanetData)
    i3D_Node_SetRotation(3,PlanetData\xRot,PlanetData\yRot+0.15,PlanetData\zRot)
    
    ;check keypress
    ExamineKeyboard()
    If KeyboardPushed(#PB_Key_Left)
      i3D_Node_SetPosition(1,ShipData\xPos - 0.05,ShipData\yPos,ShipData\zPos)
    ElseIf KeyboardPushed(#PB_Key_Right)
      i3D_Node_SetPosition(1,ShipData\xPos + 0.05,ShipData\yPos,ShipData\zPos)
    ElseIf KeyboardPushed(#PB_Key_Down)
      i3D_Node_SetPosition(1,ShipData\xPos,ShipData\yPos,ShipData\zPos + 0.05)
    ElseIf KeyboardPushed(#PB_Key_Up)
      i3D_Node_SetPosition(1,ShipData\xPos,ShipData\yPos,ShipData\zPos - 0.05)
    ElseIf KeyboardPushed(#PB_Key_Escape)
      i3D_Close3D()
    EndIf

  Wend 
Else
  MessageRequester("Error","Could not initialize the 3D device. Make sure you have PB_Irrlicht.dll")
EndIf

i3D_DoCleanUp()
; ; 
; ShipData.I3D_NODEDATA
; If i3D_Initialize3D(#I3D_DRIVER_OPENGL, 640,480,32,0,1,@EventHandler()) 
;   ;set startup values
;   InitKeyboard() 
;   i3D_SetShadowColor(255,0,0,0)
;   i3D_SetBackgroundColor(155,90,90,90)
;   i3D_SetWindowCaption("Test PB_Irrlicht - Version: " + i3D_GetEngineVersion())
;   i3D_GUI_SetFont("./fontcourier.bmp")
;   i3D_LoadMesh("./ship1.ms3d")
;   i3D_LoadTexture("./ship1.bmp")
;   i3D_AddAnimatedNode("./ship1.ms3d",1,1,1,1,1)
;   i3D_Node_SetMaterialType(1,#I3D_MATERIALTYPE_SPHERE_MAP)
;   i3D_Node_SetTexture("./ship1.bmp",1,0) 
;   i3D_AddDynamicLight(1,5,5,5,100,255,255,255,100)
;   i3D_Camera_SetPosition(20,50,20)
;    
;   ;create GUI
;   EditBox1.l = i3D_GUI_CreateEditBox("Edit box sample",101,100,100,250,150,1)
;   Button1.l = i3D_GUI_CreateButton("Wireframe",102,400,100,500,150)
;   Static1.l = i3D_GUI_CreateStaticText("Static text is fun!",103,250,250,400,300,0,0)
;   MsgBox.l = i3D_GUI_CreateMessageBox("Test MsgBox","Testing 1 2 3",104,1,#I3D_GUI_MSGBOX_OK + #I3D_GUI_MSGBOX_CANCEL)
;   
;   While i3D_IsRunning()
;     i3D_Camera_PointAtNode(1)
;     
;     ;Start the rendering sequence - ORDER MATTERS
;     i3D_BeginRender(1,1)
;     
;     ;Draw2DText must be done between beginrender and endrender, no other time
;     i3D_Draw2DText("./fontcourier.bmp",10,10,"Hello and welcome to PB_Irrlicht by dracflamloc!",255,255,255,255,0)
;     i3D_Draw2DText("./fontcourier.bmp",10,30,"http://www.dracsoft.com/",255,255,255,255,0)
;     i3D_Draw2DText("./fontcourier.bmp",10,50,"X: " + Str(ShipData\xPos),255,255,255,255,0)
;     i3D_Draw2DText("./fontcourier.bmp",10,70,"Z: " + Str(ShipData\zPos),255,255,255,255,0)
;     i3D_Draw2DText("./fontcourier.bmp",10,90,"FPS: " + Str(i3D_GetFPS()),255,255,255,255,0)
;     
;     ;Render to the screen 
;     i3D_RenderScene()
;     i3D_RenderGUI()
;     
;     ;End the rendering sequence
;     i3D_EndRender()
;     
;     ;update data and rotate object
;     i3D_Node_GetData(1,@ShipData)
;     i3D_Node_SetRotation(1,ShipData\xRot+0.05,ShipData\yRot+0.05,ShipData\zRot-0.05)
;     
;     ;check keypress
;     ExamineKeyboard() 
;     If KeyboardReleased(#PB_Key_Escape)
;       i3D_Close3D()
;     ElseIf KeyboardPushed(#PB_Key_Left)
;       i3D_Node_SetPosition(1,ShipData\xPos - 0.05,ShipData\yPos,ShipData\zPos)
;     ElseIf KeyboardPushed(#PB_Key_Right)
;       i3D_Node_SetPosition(1,ShipData\xPos + 0.05,ShipData\yPos,ShipData\zPos)
;     ElseIf KeyboardPushed(#PB_Key_Up)
;       i3D_Node_SetPosition(1,ShipData\xPos,ShipData\yPos,ShipData\zPos - 0.05)
;     ElseIf KeyboardPushed(#PB_Key_Down)
;       i3D_Node_SetPosition(1,ShipData\xPos,ShipData\yPos,ShipData\zPos + 0.05)
;     EndIf
;     
;     ;for now use the global vars to handle the gui event - TODO: Make into a structure
;     HandleGUIEvent(LastGuiID,LastGuiEvent)
;   Wend 
; Else
;   MessageRequester("Error","Could not initialize the 3D device.")
; EndIf
; 
; i3D_DoCleanUp()
i3D_End()
End
; ExecutableFormat=Windows
; CursorPosition=466
; FirstLine=467
; DisableDebugger
; EOF