; PBOSL_SQLite3
; Demonstation for then binding-functions
; Please run in debugmode
; Version 1.0

If SQLite3_InitLib("sqlite3.dll") = #False 
  MessageRequester("PBOSL_SQLite3 (bind_test)", "Couldn't initialize sqlite3.dll")
  End
EndIf

dbHandler = SQLite3_CreateDatabase("bind_test.db", #True)
  
If dbHandler = 0 
  MessageRequester("PBOSL_SQLite3 (bind_test)", "Couldn't create database 'bind_test.db'")
  End
EndIf

SQLite3_Execute("Create Table tblTest (fldInteger Integer, fldText Text)",dbHandler)

; Write 100 Items

Debug "##############################################" 
Debug "Write 100 Items into table tlbTest"
Debug "##############################################" 
Debug ""

For lCounter = 0 To 99
  
  Debug "-> Prepare" 
  Statement = SQLite3_Prepare(dbHandler, "Insert Into tblTest (fldInteger, fldText) Values (?, ?);")
  Debug "Statement: " + Str(Statement)
  Debug "LastMessage: " + SQLite3_GetLastMessage()
  Debug ""
  
  If Statement
    
    Debug "-> Bind Integer"
    ReturnValue = SQLite3_Bind_Int(Statement, 1, lCounter)
    Debug "Returnvalue: " + Str(ReturnValue)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
    Debug "-> Bind Text"
    sDummy$ = "TestText" + Str(lCounter)
    ReturnValue = SQLite3_Bind_Text(Statement, 2, @sDummy$)
    Debug "Returnvalue: " + Str(ReturnValue)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
    Debug "-> Step"
    ReturnValue = SQLite3_Step(Statement)
    Debug "Returnvalue: " + Str(ReturnValue)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
    Debug "-> Finalize"
    ReturnValue = SQLite3_Finalize(Statement)
    Debug "Returnvalue: " + Str(ReturnValue)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
  EndIf
  
Next lCounter

; Read all Items in table tblTest

Debug "##############################################" 
Debug "Read all Items in table tblTest" 
Debug "##############################################" 
Debug ""

Debug "-> Preparing SQL-Statement" 
Statement = SQLite3_Prepare(dbHandler, "Select * From tblTest;")
Debug "Statement: " + Str(Statement)
Debug "LastMessage: " + SQLite3_GetLastMessage()
Debug ""
  
If Statement
  
  Repeat
    
    Debug "-> Step"
    ReturnValue = SQLite3_Step(Statement)
    Debug "Returnvalue: " + Str(ReturnValue)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
    If ReturnValue = #SQLITE3_DONE
      Break
    EndIf
    
    ; Get content of the integerfield
    lDummy.l = SQLite3_Column_Int(Statement, 0)
    Debug "Content of integerfield: " + Str(lDummy)
    Debug ""
    
    ; Get length and content of the textfield
    
    Debug "-> SQLite3_Column_Bytes"
    FieldLen = SQLite3_Column_Bytes(Statement, 1) ; Get fieldlength
    Debug "Fieldlength: " + Str(FieldLen)
    Debug "LastMessage: " + SQLite3_GetLastMessage()
    Debug ""
    
    If FieldLen
      
      SourceMem = SQLite3_Column_Text(Statement, 1)
      
      Debug "Address of Textfield: " + Str(SourceMem)
      
      sDummy$ = PeekS(SourceMem)
      
      Debug "Content of textfield: " + sDummy$
      Debug ""
      
    EndIf
    
  ForEver
  
  Debug "-> Finalize"
  ReturnValue = SQLite3_Finalize(Statement)
  Debug "Returnvalue: " + Str(ReturnValue)
  Debug "LastMessage: " + SQLite3_GetLastMessage()
  Debug ""
  
EndIf

SQLite3_CloseDatabase(dbHandler)

SQLite3_End()

MessageRequester("PBOSL_SQLite3 (bind_test)", "Ready")

; IDE Options = PureBasic v3.94 (Windows - x86)
; EnableXP
; HideErrorLog