Enumeration
  #frmMain
  #lstOutput
EndEnumeration

Global dbHandler

Declare AddOutput(sMessage.s)
Declare.l PrepareDatabase()
Declare WriteBlob()
Declare ReadBlob()

If OpenWindow(#frmMain, 0,0,300,300,#PB_Window_SystemMenu | #PB_Window_ScreenCentered ,"")
  If CreateGadgetList(WindowID(#frmMain))
    ListViewGadget(#lstOutput, 5,5,290,290)
    bolOK = #True
  EndIf
EndIf

If bolOK = #False
  End
EndIf

; Prepare Database

If SQLite3_InitLib("sqlite3.dll") = #False 
  MessageRequester("PBOSL_SQLite3 (blob_test)", "Couldn't initialize sqlite3.dll")
  End
EndIf

dbHandler = SQLite3_CreateDatabase("blob_test.db", #True)
SQLite3_Execute("Create Table tblBlob (fldKey Text, fldBlob BLOB)",dbHandler)
    
If dbHandler = 0 
  MessageRequester("PBOSL_SQLite3 (blob_test)", "Couldn't create database 'blob_test.db'")
  End
EndIf

WriteBlob()
ReadBlob()

SQLite3_CloseDatabase(dbHandler)

SQLite3_End()

Repeat
  
Until WaitWindowEvent()=#PB_Event_CloseWindow

Procedure AddOutput(sMessage.s)
  AddGadgetItem(#lstOutput, -1, sMessage)
  SetGadgetItemState(#lstOutput, CountGadgetItems(#lstOutput)-1 , 1)
EndProcedure

Procedure WriteBlob()
  
  ; Write BLOB
  
  AddOutput("Write Blobs")
  AddOutput("++++++++++++++++++")
  
  For lCounter = 0 To 2
    
    AddOutput("Loop No. " + Str(lCounter+1) + ":")
    AddOutput("")
    
    FF = ReadFile(#PB_Any, "demodata\image" + Str(lCounter) + ".jpg")
    
    If FF
      
      FileLen = Lof()
      MemBuffer = AllocateMemory(FileLen)
      ReadData(MemBuffer, FileLen)
      CloseFile(FF)

      
      AddOutput("-> Prepare " + Str(lCounter))
      Statement = SQLite3_Prepare(dbHandler, "insert into tblBlob (fldKey, fldBlob) values (?, ?);")
      AddOutput("Statement: " + Str(Statement))
      AddOutput("LastMessage: " + SQLite3_GetLastMessage())
      AddOutput("")
      
      If Statement
        
        Key$=Str(lCounter)
        
        AddOutput("-> Bind Text")
        ReturnValue = SQLite3_Bind_Text(Statement, 1, @Key$)
        AddOutput("Returnvalue: " + Str(ReturnValue))
        AddOutput("LastMessage: " + SQLite3_GetLastMessage())
        AddOutput("")
        
        AddOutput("-> Bind Blob")
        ReturnValue = SQLite3_Bind_Blob(Statement, 2, MemBuffer, FileLen)
        AddOutput("Returnvalue: " + Str(ReturnValue))
        AddOutput("LastMessage: " + SQLite3_GetLastMessage())
        AddOutput("")
        
        AddOutput("-> Step")
        ReturnValue = SQLite3_Step(Statement)
        AddOutput("Returnvalue: " + Str(ReturnValue))
        AddOutput("LastMessage: " + SQLite3_GetLastMessage())
        AddOutput("")
        
        AddOutput("-> Finalize")
        ReturnValue = SQLite3_Finalize(Statement)
        AddOutput("Returnvalue: " + Str(ReturnValue))
        AddOutput("LastMessage: " + SQLite3_GetLastMessage())
        AddOutput("")
        
      EndIf  
      
      FreeMemory(MemBuffer)
      
    EndIf
    
  Next lCounter
  
EndProcedure  

Procedure ReadBlob()
  
  ; Read BLOB
  
  AddOutput("")
  AddOutput("Read Blob")
  AddOutput("++++++++++++++++++")
  
  AddOutput("-> Prepare")
  Statement = SQLite3_Prepare(dbHandler, "Select fldBlob From tblBlob")
  AddOutput("Statement: " + Str(Statement))
  AddOutput("LastMessage: " + SQLite3_GetLastMessage())
  AddOutput("")
  
  If Statement
    
    Repeat
      
      AddOutput("-> Step")
      ReturnValue = SQLite3_Step(Statement)
      AddOutput("Returnvalue: " + Str(ReturnValue))
      AddOutput("LastMessage: " + SQLite3_GetLastMessage())
      AddOutput("")
      
      If ReturnValue = #SQLITE3_DONE
        Break
      EndIf
      
      AddOutput("-> SQLite3_Column_Bytes")
      FieldLen = SQLite3_Column_Bytes(Statement, 0) ; Feldlnge ermitteln
      AddOutput("Fieldlength: " + Str(FieldLen))
      AddOutput("LastMessage: " + SQLite3_GetLastMessage())
      AddOutput("")
      
      If FieldLen > 0
        
        MemBuffer = AllocateMemory(FieldLen)
        
        SourceMem = SQLite3_Column_Blob(Statement, 0)
        
        AddOutput("Address of Blob: " + Str(SourceMem))
        
        CopyMemory(SourceMem, MemBuffer, FieldLen)
        
        ; Here you can save the binary-datablock
        
        ; CreateFile(1,"D:\img" + Str(lCounter) + ".jpg")
        ; WriteData(MemBuffer, FieldLen)
        ; CloseFile(1)
        
        FreeMemory(MemBuffer)
        
        AddOutput("")
        
        lCounter + 1
        
      EndIf
      
    ForEver
    
    AddOutput("-> Finalize")
    ReturnValue = SQLite3_Finalize(Statement)
    AddOutput("Returnvalue: " + Str(ReturnValue))
    AddOutput("LastMessage: " + SQLite3_GetLastMessage())
    AddOutput("")
    
  EndIf  
  
EndProcedure

; IDE Options = PureBasic v3.94 (Windows - x86)
; EnableXP
; HideErrorLog