
;******************************************************************************************
;'egrid' editable grid control. By Stephen Rodriguez.
;******************************************************************************************

;                                 DEMONSTRATION PROGRAM 1.


;******************************************************************************************
;This demo program simply sets up a default egrid with resizable columns, no colours,
;no validation of user actions etc.
;
;It does show how to change the header size and fonts though.
;******************************************************************************************


;***************************************MUST INCLUDE***************************************
;XIncludeFile "egrid_UserFunctions.pb" 
;******************************************************************************************


;*****************************************FONT DATA****************************************
Enumeration
  #head1
  #head2
  #main
EndEnumeration
LoadFont(#head1,"Arial", 24)
LoadFont(#head2,"Arial", 16, #PB_Font_Bold)
LoadFont(#main,"Arial", 12)
;******************************************************************************************


;*************************************WINDOW + GADGET LIST*********************************
If OpenWindow(0,0,0,640,300,#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered,"egrids test program.") And CreateGadgetList(WindowID(0))
  ShowWindow_(WindowID(), #SW_MAXIMIZE)
;******************************************************************************************


;********************************************EGRID*****************************************
;Create an egrid with resizable columns.
  egrid_CreateGrid(1, WindowWidth()/4, WindowHeight()/8, WindowWidth()/2, WindowHeight()/2,21,0, #egrid_ResizeColumnsTrue)
;******************************************************************************************

;********************************************TEXT GADGET***********************************
  TextGadget(4,40, 21*WindowHeight()/32, WindowWidth()-80, WindowHeight()/4, "")
  SetGadgetFont(4,UseFont(#main))
  text$="No frills, just a basic egrid with all cells being of the default 'String' type."
  text$+Chr(10)+Chr(10)+"For different celltypes, multiple colours/fonts, cell/data validation etc. the developer needs to "
  text$+"create a 'CellCallback function' within their application. Examples can be found in all the other demo programs."
  SetGadgetText(4, text$)

;*******************************************BUTTONS****************************************
  ButtonGadget(2,WindowWidth()/10,WindowHeight()/8,110,20,"Header font 1")
  ButtonGadget(3,WindowWidth()/10,WindowHeight()/8+30,110,20,"Header font 2")
;******************************************************************************************

;***************************************ADD DATA TO EGRID**********************************
  For b=1 To 50 ;50 columns. NOTE the column index begins at 1!
    AddGadgetColumn(1,b,"Col " + Str(b),60)
  Next
  For b=0 To 99; Add 100 rows.
    AddGadgetItem(1,-1,"") ;The "" is for the zero column which is always invisible in an egrid.
  Next
  For i = 0 To 99
    For j = 1 To 50
      SetGadgetItemText(1,i,"(" + Str(i) + ", "+Str(j) + ")",j)
    Next j
  Next i            
;NOTE that the zero column of an egrid is blanked out, hence the "" in the above AddGadgetItem() command.
;******************************************************************************************


;*****************************************EVENT LOOP***************************************
  Repeat
    EventID = WaitWindowEvent()
        
    Select EventID
     
      Case #PB_Event_Gadget
        Select EventGadgetID() 
          Case 2
            egrid_SetHeaderFont(1, UseFont(#head1))
          Case 3
            egrid_SetHeaderFont(1, UseFont(#head2))
      EndSelect
    EndSelect
  Until EventID = #PB_Event_CloseWindow
  
EndIf
  
End
;******************************************************************************************

; IDE Options = PureBasic v3.94 (Windows - x86)
; EnableAsm
; EnableXP
; Executable = test.exe
; DisableDebugger